# coding: utf-8

"""
    Chat API SDK

    The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: sale@chat-api.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class InstanceStatusStatusData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'substatus': 'str',
        'title': 'str',
        'msg': 'str',
        'submsg': 'str',
        'actions': 'InstanceStatusStatusDataActions',
        'reason': 'str'
    }

    attribute_map = {
        'substatus': 'substatus',
        'title': 'title',
        'msg': 'msg',
        'submsg': 'submsg',
        'actions': 'actions',
        'reason': 'reason'
    }

    def __init__(self, substatus=None, title=None, msg=None, submsg=None, actions=None, reason=None):  # noqa: E501
        """InstanceStatusStatusData - a model defined in OpenAPI"""  # noqa: E501

        self._substatus = None
        self._title = None
        self._msg = None
        self._submsg = None
        self._actions = None
        self._reason = None
        self.discriminator = None

        if substatus is not None:
            self.substatus = substatus
        if title is not None:
            self.title = title
        if msg is not None:
            self.msg = msg
        if submsg is not None:
            self.submsg = submsg
        if actions is not None:
            self.actions = actions
        if reason is not None:
            self.reason = reason

    @property
    def substatus(self):
        """Gets the substatus of this InstanceStatusStatusData.  # noqa: E501

        Instance Substatus  # noqa: E501

        :return: The substatus of this InstanceStatusStatusData.  # noqa: E501
        :rtype: str
        """
        return self._substatus

    @substatus.setter
    def substatus(self, substatus):
        """Sets the substatus of this InstanceStatusStatusData.

        Instance Substatus  # noqa: E501

        :param substatus: The substatus of this InstanceStatusStatusData.  # noqa: E501
        :type: str
        """
        allowed_values = ["normal", "loading", "offline", "expired", "opening", "pairing", "timeout", "computer", "phone", "battery_low_1", "battery_low_2"]  # noqa: E501
        if substatus not in allowed_values:
            raise ValueError(
                "Invalid value for `substatus` ({0}), must be one of {1}"  # noqa: E501
                .format(substatus, allowed_values)
            )

        self._substatus = substatus

    @property
    def title(self):
        """Gets the title of this InstanceStatusStatusData.  # noqa: E501

        Status title in the language of the instance  # noqa: E501

        :return: The title of this InstanceStatusStatusData.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this InstanceStatusStatusData.

        Status title in the language of the instance  # noqa: E501

        :param title: The title of this InstanceStatusStatusData.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def msg(self):
        """Gets the msg of this InstanceStatusStatusData.  # noqa: E501

        Status message in the language of the instance  # noqa: E501

        :return: The msg of this InstanceStatusStatusData.  # noqa: E501
        :rtype: str
        """
        return self._msg

    @msg.setter
    def msg(self, msg):
        """Sets the msg of this InstanceStatusStatusData.

        Status message in the language of the instance  # noqa: E501

        :param msg: The msg of this InstanceStatusStatusData.  # noqa: E501
        :type: str
        """

        self._msg = msg

    @property
    def submsg(self):
        """Gets the submsg of this InstanceStatusStatusData.  # noqa: E501

        Additional status message in the language of the instance  # noqa: E501

        :return: The submsg of this InstanceStatusStatusData.  # noqa: E501
        :rtype: str
        """
        return self._submsg

    @submsg.setter
    def submsg(self, submsg):
        """Sets the submsg of this InstanceStatusStatusData.

        Additional status message in the language of the instance  # noqa: E501

        :param submsg: The submsg of this InstanceStatusStatusData.  # noqa: E501
        :type: str
        """

        self._submsg = submsg

    @property
    def actions(self):
        """Gets the actions of this InstanceStatusStatusData.  # noqa: E501


        :return: The actions of this InstanceStatusStatusData.  # noqa: E501
        :rtype: InstanceStatusStatusDataActions
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this InstanceStatusStatusData.


        :param actions: The actions of this InstanceStatusStatusData.  # noqa: E501
        :type: InstanceStatusStatusDataActions
        """

        self._actions = actions

    @property
    def reason(self):
        """Gets the reason of this InstanceStatusStatusData.  # noqa: E501

        The reason why the instance is in \"loading\" status  # noqa: E501

        :return: The reason of this InstanceStatusStatusData.  # noqa: E501
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """Sets the reason of this InstanceStatusStatusData.

        The reason why the instance is in \"loading\" status  # noqa: E501

        :param reason: The reason of this InstanceStatusStatusData.  # noqa: E501
        :type: str
        """
        allowed_values = ["connecting", "syncing", "offline", "proxyblock", "conflict"]  # noqa: E501
        if reason not in allowed_values:
            raise ValueError(
                "Invalid value for `reason` ({0}), must be one of {1}"  # noqa: E501
                .format(reason, allowed_values)
            )

        self._reason = reason

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstanceStatusStatusData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
