# coding: utf-8

"""
    Chat API SDK

    The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: sale@chat-api.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Message(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'body': 'str',
        'type': 'str',
        'sender_name': 'str',
        'from_me': 'bool',
        'author': 'str',
        'time': 'int',
        'chat_id': 'str',
        'message_number': 'int'
    }

    attribute_map = {
        'id': 'id',
        'body': 'body',
        'type': 'type',
        'sender_name': 'senderName',
        'from_me': 'fromMe',
        'author': 'author',
        'time': 'time',
        'chat_id': 'chatId',
        'message_number': 'messageNumber'
    }

    def __init__(self, id=None, body=None, type=None, sender_name=None, from_me=None, author=None, time=None, chat_id=None, message_number=None):  # noqa: E501
        """Message - a model defined in OpenAPI"""  # noqa: E501

        self._id = None
        self._body = None
        self._type = None
        self._sender_name = None
        self._from_me = None
        self._author = None
        self._time = None
        self._chat_id = None
        self._message_number = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if body is not None:
            self.body = body
        if type is not None:
            self.type = type
        if sender_name is not None:
            self.sender_name = sender_name
        if from_me is not None:
            self.from_me = from_me
        if author is not None:
            self.author = author
        if time is not None:
            self.time = time
        if chat_id is not None:
            self.chat_id = chat_id
        if message_number is not None:
            self.message_number = message_number

    @property
    def id(self):
        """Gets the id of this Message.  # noqa: E501

        unique id  # noqa: E501

        :return: The id of this Message.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Message.

        unique id  # noqa: E501

        :param id: The id of this Message.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def body(self):
        """Gets the body of this Message.  # noqa: E501

        text message for type \"chat\", or link to download the file for \"ptt\", \"image\", \"audio\", \"video\" and \"document\", or latitude and longitude for \"location\", or message \"[Call]\" for \"call_log\"  # noqa: E501

        :return: The body of this Message.  # noqa: E501
        :rtype: str
        """
        return self._body

    @body.setter
    def body(self, body):
        """Sets the body of this Message.

        text message for type \"chat\", or link to download the file for \"ptt\", \"image\", \"audio\", \"video\" and \"document\", or latitude and longitude for \"location\", or message \"[Call]\" for \"call_log\"  # noqa: E501

        :param body: The body of this Message.  # noqa: E501
        :type: str
        """

        self._body = body

    @property
    def type(self):
        """Gets the type of this Message.  # noqa: E501

        type of the message  # noqa: E501

        :return: The type of this Message.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Message.

        type of the message  # noqa: E501

        :param type: The type of this Message.  # noqa: E501
        :type: str
        """
        allowed_values = ["chat", "image", "ptt", "document", "audio", "video", "location", "call_log"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def sender_name(self):
        """Gets the sender_name of this Message.  # noqa: E501

        Sender name  # noqa: E501

        :return: The sender_name of this Message.  # noqa: E501
        :rtype: str
        """
        return self._sender_name

    @sender_name.setter
    def sender_name(self, sender_name):
        """Sets the sender_name of this Message.

        Sender name  # noqa: E501

        :param sender_name: The sender_name of this Message.  # noqa: E501
        :type: str
        """

        self._sender_name = sender_name

    @property
    def from_me(self):
        """Gets the from_me of this Message.  # noqa: E501

        true - outgoing, false - incoming  # noqa: E501

        :return: The from_me of this Message.  # noqa: E501
        :rtype: bool
        """
        return self._from_me

    @from_me.setter
    def from_me(self, from_me):
        """Sets the from_me of this Message.

        true - outgoing, false - incoming  # noqa: E501

        :param from_me: The from_me of this Message.  # noqa: E501
        :type: bool
        """

        self._from_me = from_me

    @property
    def author(self):
        """Gets the author of this Message.  # noqa: E501

        Author ID of the message, useful for groups  # noqa: E501

        :return: The author of this Message.  # noqa: E501
        :rtype: str
        """
        return self._author

    @author.setter
    def author(self, author):
        """Sets the author of this Message.

        Author ID of the message, useful for groups  # noqa: E501

        :param author: The author of this Message.  # noqa: E501
        :type: str
        """

        self._author = author

    @property
    def time(self):
        """Gets the time of this Message.  # noqa: E501

        send time, unix timestamp  # noqa: E501

        :return: The time of this Message.  # noqa: E501
        :rtype: int
        """
        return self._time

    @time.setter
    def time(self, time):
        """Sets the time of this Message.

        send time, unix timestamp  # noqa: E501

        :param time: The time of this Message.  # noqa: E501
        :type: int
        """

        self._time = time

    @property
    def chat_id(self):
        """Gets the chat_id of this Message.  # noqa: E501

        chat ID  # noqa: E501

        :return: The chat_id of this Message.  # noqa: E501
        :rtype: str
        """
        return self._chat_id

    @chat_id.setter
    def chat_id(self, chat_id):
        """Sets the chat_id of this Message.

        chat ID  # noqa: E501

        :param chat_id: The chat_id of this Message.  # noqa: E501
        :type: str
        """

        self._chat_id = chat_id

    @property
    def message_number(self):
        """Gets the message_number of this Message.  # noqa: E501

        sequence number of the message in the database  # noqa: E501

        :return: The message_number of this Message.  # noqa: E501
        :rtype: int
        """
        return self._message_number

    @message_number.setter
    def message_number(self, message_number):
        """Sets the message_number of this Message.

        sequence number of the message in the database  # noqa: E501

        :param message_number: The message_number of this Message.  # noqa: E501
        :type: int
        """

        self._message_number = message_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Message):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
